#!/usr/bin/env python3

from libervia.server.constants import Const as C
from sat.tools.common import data_format
from sat.core.log import getLogger

log = getLogger(__name__)

name = "list_create"
access = C.PAGES_ACCESS_PROFILE
template = "list/create.html"


def parse_url(self, request):
    self.get_path_args(request, ["template_id"])
    data = self.get_r_data(request)
    if data["template_id"]:
        self.http_redirect(
            request,
            self.get_page_by_name("list_create_from_tpl").get_url(data["template_id"])
        )


async def prepare_render(self, request):
    template_data = request.template_data
    profile = self.get_profile(request)
    tpl_raw = await self.host.bridge_call(
        "list_templates_names_get",
        "",
        profile,
    )
    lists_templates = data_format.deserialise(tpl_raw, type_check=list)
    template_data["icons_names"] = {tpl['icon'] for tpl in lists_templates}
    template_data["lists_templates"] = [
        {
            "icon": tpl["icon"],
            "name": tpl["name"],
            "url": self.get_url(tpl["id"]),
        }
        for tpl in lists_templates
    ]
